// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.0.0
// Generated from file `Endpoint.ice'

#ifndef __Ice_Endpoint_h__
#define __Ice_Endpoint_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 300
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_API
#   ifdef ICE_API_EXPORTS
#       define ICE_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace Ice
{

class Endpoint;
ICE_API bool operator==(const Endpoint&, const Endpoint&);
ICE_API bool operator!=(const Endpoint&, const Endpoint&);
ICE_API bool operator<(const Endpoint&, const Endpoint&);

}

namespace IceInternal
{

ICE_API void incRef(::Ice::Endpoint*);
ICE_API void decRef(::Ice::Endpoint*);

}

namespace Ice
{

typedef ::IceInternal::Handle< ::Ice::Endpoint> EndpointPtr;

}

namespace Ice
{

typedef ::std::vector< ::Ice::EndpointPtr> EndpointSeq;

}

namespace Ice
{

class ICE_API Endpoint : virtual public ::Ice::LocalObject
{
public:


    virtual ::std::string toString() const = 0;
};

}

#endif
