// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.0.0
// Generated from file `Admin.ice'

#ifndef __IceGrid_Admin_h__
#define __IceGrid_Admin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <Ice/SliceChecksumDict.h>
#include <IceGrid/Exception.h>
#include <IceGrid/Descriptor.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 300
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_GRID_API
#   ifdef ICE_GRID_API_EXPORTS
#       define ICE_GRID_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_GRID_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceGrid
{

class Admin;
ICE_GRID_API bool operator==(const Admin&, const Admin&);
ICE_GRID_API bool operator!=(const Admin&, const Admin&);
ICE_GRID_API bool operator<(const Admin&, const Admin&);

}

}

namespace IceGrid
{

class Admin;
ICE_GRID_API bool operator==(const Admin&, const Admin&);
ICE_GRID_API bool operator!=(const Admin&, const Admin&);
ICE_GRID_API bool operator<(const Admin&, const Admin&);

}

namespace IceInternal
{

ICE_GRID_API void incRef(::IceGrid::Admin*);
ICE_GRID_API void decRef(::IceGrid::Admin*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Admin*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Admin*);

}

namespace IceGrid
{

typedef ::IceInternal::Handle< ::IceGrid::Admin> AdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Admin> AdminPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdminPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, AdminPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdminPtr&);
ICE_GRID_API void __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

namespace IceGrid
{

enum ServerState
{
    Inactive,
    Activating,
    Active,
    Deactivating,
    Destroying,
    Destroyed
};

ICE_GRID_API void __write(::IceInternal::BasicStream*, ServerState);
ICE_GRID_API void __read(::IceInternal::BasicStream*, ServerState&);

typedef ::std::map< ::std::string, ::Ice::ObjectPrx> StringObjectProxyDict;

class __U__StringObjectProxyDict { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const StringObjectProxyDict&, __U__StringObjectProxyDict);
ICE_GRID_API void __read(::IceInternal::BasicStream*, StringObjectProxyDict&, __U__StringObjectProxyDict);

struct ObjectInfo
{
    ::Ice::ObjectPrx proxy;
    ::std::string type;

    ICE_GRID_API bool operator==(const ObjectInfo&) const;
    ICE_GRID_API bool operator!=(const ObjectInfo&) const;
    ICE_GRID_API bool operator<(const ObjectInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceGrid::ObjectInfo> ObjectInfoSeq;

class __U__ObjectInfoSeq { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const ObjectInfoSeq&, __U__ObjectInfoSeq);
ICE_GRID_API void __read(::IceInternal::BasicStream*, ObjectInfoSeq&, __U__ObjectInfoSeq);

struct AdapterInfo
{
    ::Ice::ObjectPrx proxy;
    ::std::string replicaGroupId;

    ICE_GRID_API bool operator==(const AdapterInfo&) const;
    ICE_GRID_API bool operator!=(const AdapterInfo&) const;
    ICE_GRID_API bool operator<(const AdapterInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::map< ::std::string, ::IceGrid::AdapterInfo> AdapterInfoDict;

class __U__AdapterInfoDict { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdapterInfoDict&, __U__AdapterInfoDict);
ICE_GRID_API void __read(::IceInternal::BasicStream*, AdapterInfoDict&, __U__AdapterInfoDict);

struct ServerInfo
{
    ::std::string application;
    ::std::string node;
    ::IceGrid::ServerDescriptorPtr descriptor;

    ICE_GRID_API bool operator==(const ServerInfo&) const;
    ICE_GRID_API bool operator!=(const ServerInfo&) const;
    ICE_GRID_API bool operator<(const ServerInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

struct NodeInfo
{
    ::std::string os;
    ::std::string hostname;
    ::std::string release;
    ::std::string version;
    ::std::string machine;
    ::Ice::Int nProcessors;
    ::std::string dataDir;

    ICE_GRID_API bool operator==(const NodeInfo&) const;
    ICE_GRID_API bool operator!=(const NodeInfo&) const;
    ICE_GRID_API bool operator<(const NodeInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

struct LoadInfo
{
    ::Ice::Float avg1;
    ::Ice::Float avg5;
    ::Ice::Float avg15;

    ICE_GRID_API bool operator==(const LoadInfo&) const;
    ICE_GRID_API bool operator!=(const LoadInfo&) const;
    ICE_GRID_API bool operator<(const LoadInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

}

namespace IceGrid
{

class ICE_GRID_API AMI_Admin_patchApplication : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, bool, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_patchApplication> AMI_Admin_patchApplicationPtr;

class ICE_GRID_API AMD_Admin_patchApplication : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Admin_patchApplication> AMD_Admin_patchApplicationPtr;

class ICE_GRID_API AMI_Admin_enableServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, bool, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_enableServer> AMI_Admin_enableServerPtr;

class ICE_GRID_API AMI_Admin_startServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_startServer> AMI_Admin_startServerPtr;

class ICE_GRID_API AMI_Admin_stopServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_stopServer> AMI_Admin_stopServerPtr;

class ICE_GRID_API AMI_Admin_patchServer : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, bool, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_patchServer> AMI_Admin_patchServerPtr;

class ICE_GRID_API AMD_Admin_patchServer : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::IceGrid::AMD_Admin_patchServer> AMD_Admin_patchServerPtr;

class ICE_GRID_API AMI_Admin_getNodeLoad : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::IceGrid::LoadInfo&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_getNodeLoad> AMI_Admin_getNodeLoadPtr;

class ICE_GRID_API AMI_Admin_shutdownNode : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::AdminPrx&, const ::std::string&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_Admin_shutdownNode> AMI_Admin_shutdownNodePtr;

}

namespace IceAsync
{

namespace IceGrid
{

class ICE_GRID_API AMD_Admin_patchApplication : public ::IceGrid::AMD_Admin_patchApplication, public ::IceInternal::IncomingAsync
{
public:

    AMD_Admin_patchApplication(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

class ICE_GRID_API AMD_Admin_patchServer : public ::IceGrid::AMD_Admin_patchServer, public ::IceInternal::IncomingAsync
{
public:

    AMD_Admin_patchServer(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace IceGrid
{

class ICE_GRID_API Admin : virtual public ::IceProxy::Ice::Object
{
public:

    void addApplication(const ::IceGrid::ApplicationDescriptor&);
    void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    void syncApplication(const ::IceGrid::ApplicationDescriptor&);
    void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&);
    void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    void removeApplication(const ::std::string&);
    void removeApplication(const ::std::string&, const ::Ice::Context&);

    void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&);
    void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&, const ::Ice::Context&);

    void patchApplication(const ::std::string&, bool);
    void patchApplication(const ::std::string&, bool, const ::Ice::Context&);
    void patchApplication_async(const::IceGrid::AMI_Admin_patchApplicationPtr&, const ::std::string&, bool);
    void patchApplication_async(const::IceGrid::AMI_Admin_patchApplicationPtr&, const ::std::string&, bool, const ::Ice::Context&);

    ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&);
    ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor();
    ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor(const ::Ice::Context&);

    ::Ice::StringSeq getAllApplicationNames();
    ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    ::IceGrid::ServerInfo getServerInfo(const ::std::string&);
    ::IceGrid::ServerInfo getServerInfo(const ::std::string&, const ::Ice::Context&);

    ::IceGrid::ServerState getServerState(const ::std::string&);
    ::IceGrid::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    ::Ice::Int getServerPid(const ::std::string&);
    ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    void enableServer(const ::std::string&, bool);
    void enableServer(const ::std::string&, bool, const ::Ice::Context&);
    void enableServer_async(const::IceGrid::AMI_Admin_enableServerPtr&, const ::std::string&, bool);
    void enableServer_async(const::IceGrid::AMI_Admin_enableServerPtr&, const ::std::string&, bool, const ::Ice::Context&);

    bool isServerEnabled(const ::std::string&);
    bool isServerEnabled(const ::std::string&, const ::Ice::Context&);

    void startServer(const ::std::string&);
    void startServer(const ::std::string&, const ::Ice::Context&);
    void startServer_async(const::IceGrid::AMI_Admin_startServerPtr&, const ::std::string&);
    void startServer_async(const::IceGrid::AMI_Admin_startServerPtr&, const ::std::string&, const ::Ice::Context&);

    void stopServer(const ::std::string&);
    void stopServer(const ::std::string&, const ::Ice::Context&);
    void stopServer_async(const::IceGrid::AMI_Admin_stopServerPtr&, const ::std::string&);
    void stopServer_async(const::IceGrid::AMI_Admin_stopServerPtr&, const ::std::string&, const ::Ice::Context&);

    void patchServer(const ::std::string&, bool);
    void patchServer(const ::std::string&, bool, const ::Ice::Context&);
    void patchServer_async(const::IceGrid::AMI_Admin_patchServerPtr&, const ::std::string&, bool);
    void patchServer_async(const::IceGrid::AMI_Admin_patchServerPtr&, const ::std::string&, bool, const ::Ice::Context&);

    void sendSignal(const ::std::string&, const ::std::string&);
    void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int);
    void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    ::Ice::StringSeq getAllServerIds();
    ::Ice::StringSeq getAllServerIds(const ::Ice::Context&);

    ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&);
    ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    void removeAdapter(const ::std::string&);
    void removeAdapter(const ::std::string&, const ::Ice::Context&);

    ::Ice::StringSeq getAllAdapterIds();
    ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    void addObject(const ::Ice::ObjectPrx&);
    void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    void updateObject(const ::Ice::ObjectPrx&);
    void updateObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&);
    void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    void removeObject(const ::Ice::Identity&);
    void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&);
    ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&, const ::Ice::Context&);

    ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&);
    ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&, const ::Ice::Context&);

    bool pingNode(const ::std::string&);
    bool pingNode(const ::std::string&, const ::Ice::Context&);

    ::IceGrid::LoadInfo getNodeLoad(const ::std::string&);
    ::IceGrid::LoadInfo getNodeLoad(const ::std::string&, const ::Ice::Context&);
    void getNodeLoad_async(const::IceGrid::AMI_Admin_getNodeLoadPtr&, const ::std::string&);
    void getNodeLoad_async(const::IceGrid::AMI_Admin_getNodeLoadPtr&, const ::std::string&, const ::Ice::Context&);

    ::IceGrid::NodeInfo getNodeInfo(const ::std::string&);
    ::IceGrid::NodeInfo getNodeInfo(const ::std::string&, const ::Ice::Context&);

    void shutdownNode(const ::std::string&);
    void shutdownNode(const ::std::string&, const ::Ice::Context&);
    void shutdownNode_async(const::IceGrid::AMI_Admin_shutdownNodePtr&, const ::std::string&);
    void shutdownNode_async(const::IceGrid::AMI_Admin_shutdownNodePtr&, const ::std::string&, const ::Ice::Context&);

    ::std::string getNodeHostname(const ::std::string&);
    ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    ::Ice::StringSeq getAllNodeNames();
    ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    void shutdown();
    void shutdown(const ::Ice::Context&);

    ::Ice::SliceChecksumDict getSliceChecksums();
    ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IceGrid
{

class ICE_GRID_API Admin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&) = 0;

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&) = 0;

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&) = 0;

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&, const ::Ice::Context&) = 0;

    virtual void patchApplication(const ::std::string&, bool, const ::Ice::Context&) = 0;

    virtual ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor(const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&) = 0;

    virtual ::IceGrid::ServerInfo getServerInfo(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::ServerState getServerState(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void enableServer(const ::std::string&, bool, const ::Ice::Context&) = 0;

    virtual bool isServerEnabled(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void startServer(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void stopServer(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void patchServer(const ::std::string&, bool, const ::Ice::Context&) = 0;

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllServerIds(const ::Ice::Context&) = 0;

    virtual ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void removeAdapter(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&) = 0;

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&) = 0;

    virtual void updateObject(const ::Ice::ObjectPrx&, const ::Ice::Context&) = 0;

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&, const ::Ice::Context&) = 0;

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::LoadInfo getNodeLoad(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::IceGrid::NodeInfo getNodeInfo(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&) = 0;

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&) = 0;

    virtual void shutdown(const ::Ice::Context&) = 0;

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceGrid
{

class ICE_GRID_API Admin : virtual public ::IceDelegate::IceGrid::Admin,
			   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&, const ::Ice::Context&);

    virtual void patchApplication(const ::std::string&, bool, const ::Ice::Context&);

    virtual ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor(const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    virtual ::IceGrid::ServerInfo getServerInfo(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    virtual void enableServer(const ::std::string&, bool, const ::Ice::Context&);

    virtual bool isServerEnabled(const ::std::string&, const ::Ice::Context&);

    virtual void startServer(const ::std::string&, const ::Ice::Context&);

    virtual void stopServer(const ::std::string&, const ::Ice::Context&);

    virtual void patchServer(const ::std::string&, bool, const ::Ice::Context&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllServerIds(const ::Ice::Context&);

    virtual ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    virtual void removeAdapter(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void updateObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&, const ::Ice::Context&);

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::LoadInfo getNodeLoad(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::NodeInfo getNodeInfo(const ::std::string&, const ::Ice::Context&);

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    virtual void shutdown(const ::Ice::Context&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IceGrid
{

class ICE_GRID_API Admin : virtual public ::IceDelegate::IceGrid::Admin,
			   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&, const ::Ice::Context&);

    virtual void patchApplication(const ::std::string&, bool, const ::Ice::Context&);

    virtual ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor(const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Context&);

    virtual ::IceGrid::ServerInfo getServerInfo(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::ServerState getServerState(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Context&);

    virtual void enableServer(const ::std::string&, bool, const ::Ice::Context&);

    virtual bool isServerEnabled(const ::std::string&, const ::Ice::Context&);

    virtual void startServer(const ::std::string&, const ::Ice::Context&);

    virtual void stopServer(const ::std::string&, const ::Ice::Context&);

    virtual void patchServer(const ::std::string&, bool, const ::Ice::Context&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Context&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllServerIds(const ::Ice::Context&);

    virtual ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&, const ::Ice::Context&);

    virtual void removeAdapter(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Context&);

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void updateObject(const ::Ice::ObjectPrx&, const ::Ice::Context&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Context&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&, const ::Ice::Context&);

    virtual bool pingNode(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::LoadInfo getNodeLoad(const ::std::string&, const ::Ice::Context&);

    virtual ::IceGrid::NodeInfo getNodeInfo(const ::std::string&, const ::Ice::Context&);

    virtual void shutdownNode(const ::std::string&, const ::Ice::Context&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Context&);

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Context&);

    virtual void shutdown(const ::Ice::Context&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Context&);
};

}

}

namespace IceGrid
{

class ICE_GRID_API Admin : virtual public ::Ice::Object
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___syncApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void instantiateServer(const ::std::string&, const ::std::string&, const ::IceGrid::ServerInstanceDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___instantiateServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void patchApplication_async(const ::IceGrid::AMD_Admin_patchApplicationPtr&, const ::std::string&, bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___patchApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceGrid::ApplicationDescriptor getApplicationDescriptor(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getApplicationDescriptor(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::ApplicationDescriptor getDefaultApplicationDescriptor(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getDefaultApplicationDescriptor(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::StringSeq getAllApplicationNames(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllApplicationNames(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::ServerInfo getServerInfo(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerInfo(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::ServerState getServerState(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerState(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::Int getServerPid(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getServerPid(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void enableServer(const ::std::string&, bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___enableServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool isServerEnabled(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___isServerEnabled(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void startServer(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___startServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void stopServer(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___stopServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void patchServer_async(const ::IceGrid::AMD_Admin_patchServerPtr&, const ::std::string&, bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___patchServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void sendSignal(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___sendSignal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void writeMessage(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___writeMessage(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::StringSeq getAllServerIds(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllServerIds(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::StringObjectProxyDict getAdapterEndpoints(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAdapterEndpoints(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void removeAdapter(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeAdapter(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::StringSeq getAllAdapterIds(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllAdapterIds(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void addObject(const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateObject(const ::Ice::ObjectPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addObjectWithType(const ::Ice::ObjectPrx&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addObjectWithType(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeObject(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceGrid::ObjectInfo getObjectInfo(const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getObjectInfo(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::ObjectInfoSeq getAllObjectInfos(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllObjectInfos(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual bool pingNode(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___pingNode(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::LoadInfo getNodeLoad(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getNodeLoad(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::NodeInfo getNodeInfo(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getNodeInfo(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdownNode(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdownNode(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string getNodeHostname(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getNodeHostname(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::Ice::StringSeq getAllNodeNames(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAllNodeNames(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void shutdown(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___shutdown(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::SliceChecksumDict getSliceChecksums(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getSliceChecksums(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

}

#endif
