// **********************************************************************
//
// Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.0.0
// Generated from file `Observer.ice'

#ifndef __IceGrid_Observer_h__
#define __IceGrid_Observer_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <Glacier2/Session.h>
#include <IceGrid/Exception.h>
#include <IceGrid/Descriptor.h>
#include <IceGrid/Admin.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 300
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 < 0
#       error Ice patch level mismatch!
#   endif
#endif

#ifndef ICE_GRID_API
#   ifdef ICE_GRID_API_EXPORTS
#       define ICE_GRID_API ICE_DECLSPEC_EXPORT
#   else
#       define ICE_GRID_API ICE_DECLSPEC_IMPORT
#   endif
#endif

namespace IceProxy
{

namespace IceGrid
{

class NodeObserver;
ICE_GRID_API bool operator==(const NodeObserver&, const NodeObserver&);
ICE_GRID_API bool operator!=(const NodeObserver&, const NodeObserver&);
ICE_GRID_API bool operator<(const NodeObserver&, const NodeObserver&);

class RegistryObserver;
ICE_GRID_API bool operator==(const RegistryObserver&, const RegistryObserver&);
ICE_GRID_API bool operator!=(const RegistryObserver&, const RegistryObserver&);
ICE_GRID_API bool operator<(const RegistryObserver&, const RegistryObserver&);

class Query;
ICE_GRID_API bool operator==(const Query&, const Query&);
ICE_GRID_API bool operator!=(const Query&, const Query&);
ICE_GRID_API bool operator<(const Query&, const Query&);

class Admin;
ICE_GRID_API bool operator==(const Admin&, const Admin&);
ICE_GRID_API bool operator!=(const Admin&, const Admin&);
ICE_GRID_API bool operator<(const Admin&, const Admin&);

class Session;
ICE_GRID_API bool operator==(const Session&, const Session&);
ICE_GRID_API bool operator!=(const Session&, const Session&);
ICE_GRID_API bool operator<(const Session&, const Session&);

class SessionManager;
ICE_GRID_API bool operator==(const SessionManager&, const SessionManager&);
ICE_GRID_API bool operator!=(const SessionManager&, const SessionManager&);
ICE_GRID_API bool operator<(const SessionManager&, const SessionManager&);

}

}

namespace IceGrid
{

class NodeObserver;
ICE_GRID_API bool operator==(const NodeObserver&, const NodeObserver&);
ICE_GRID_API bool operator!=(const NodeObserver&, const NodeObserver&);
ICE_GRID_API bool operator<(const NodeObserver&, const NodeObserver&);

class RegistryObserver;
ICE_GRID_API bool operator==(const RegistryObserver&, const RegistryObserver&);
ICE_GRID_API bool operator!=(const RegistryObserver&, const RegistryObserver&);
ICE_GRID_API bool operator<(const RegistryObserver&, const RegistryObserver&);

class Query;
ICE_GRID_API bool operator==(const Query&, const Query&);
ICE_GRID_API bool operator!=(const Query&, const Query&);
ICE_GRID_API bool operator<(const Query&, const Query&);

class Admin;
ICE_GRID_API bool operator==(const Admin&, const Admin&);
ICE_GRID_API bool operator!=(const Admin&, const Admin&);
ICE_GRID_API bool operator<(const Admin&, const Admin&);

class Session;
ICE_GRID_API bool operator==(const Session&, const Session&);
ICE_GRID_API bool operator!=(const Session&, const Session&);
ICE_GRID_API bool operator<(const Session&, const Session&);

class SessionManager;
ICE_GRID_API bool operator==(const SessionManager&, const SessionManager&);
ICE_GRID_API bool operator!=(const SessionManager&, const SessionManager&);
ICE_GRID_API bool operator<(const SessionManager&, const SessionManager&);

}

namespace IceInternal
{

ICE_GRID_API void incRef(::IceGrid::NodeObserver*);
ICE_GRID_API void decRef(::IceGrid::NodeObserver*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::NodeObserver*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::NodeObserver*);

ICE_GRID_API void incRef(::IceGrid::RegistryObserver*);
ICE_GRID_API void decRef(::IceGrid::RegistryObserver*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::RegistryObserver*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::RegistryObserver*);

ICE_GRID_API void incRef(::IceGrid::Query*);
ICE_GRID_API void decRef(::IceGrid::Query*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Query*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Query*);

ICE_GRID_API void incRef(::IceGrid::Admin*);
ICE_GRID_API void decRef(::IceGrid::Admin*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Admin*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Admin*);

ICE_GRID_API void incRef(::IceGrid::Session*);
ICE_GRID_API void decRef(::IceGrid::Session*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::Session*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::Session*);

ICE_GRID_API void incRef(::IceGrid::SessionManager*);
ICE_GRID_API void decRef(::IceGrid::SessionManager*);

ICE_GRID_API void incRef(::IceProxy::IceGrid::SessionManager*);
ICE_GRID_API void decRef(::IceProxy::IceGrid::SessionManager*);

}

namespace IceGrid
{

typedef ::IceInternal::Handle< ::IceGrid::NodeObserver> NodeObserverPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::NodeObserver> NodeObserverPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const NodeObserverPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, NodeObserverPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const NodeObserverPtr&);
ICE_GRID_API void __patch__NodeObserverPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::RegistryObserver> RegistryObserverPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::RegistryObserver> RegistryObserverPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const RegistryObserverPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, RegistryObserverPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const RegistryObserverPtr&);
ICE_GRID_API void __patch__RegistryObserverPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Query> QueryPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Query> QueryPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const QueryPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, QueryPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const QueryPtr&);
ICE_GRID_API void __patch__QueryPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Admin> AdminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Admin> AdminPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdminPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, AdminPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdminPtr&);
ICE_GRID_API void __patch__AdminPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::Session> SessionPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::Session> SessionPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const SessionPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, SessionPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const SessionPtr&);
ICE_GRID_API void __patch__SessionPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::IceGrid::SessionManager> SessionManagerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::IceGrid::SessionManager> SessionManagerPrx;

ICE_GRID_API void __write(::IceInternal::BasicStream*, const SessionManagerPrx&);
ICE_GRID_API void __read(::IceInternal::BasicStream*, SessionManagerPrx&);
ICE_GRID_API void __write(::IceInternal::BasicStream*, const SessionManagerPtr&);
ICE_GRID_API void __patch__SessionManagerPtr(void*, ::Ice::ObjectPtr&);

}

namespace IceGrid
{

struct ServerDynamicInfo
{
    ::std::string id;
    ::IceGrid::ServerState state;
    ::Ice::Int pid;
    bool enabled;

    ICE_GRID_API bool operator==(const ServerDynamicInfo&) const;
    ICE_GRID_API bool operator!=(const ServerDynamicInfo&) const;
    ICE_GRID_API bool operator<(const ServerDynamicInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceGrid::ServerDynamicInfo> ServerDynamicInfoSeq;

class __U__ServerDynamicInfoSeq { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const ServerDynamicInfoSeq&, __U__ServerDynamicInfoSeq);
ICE_GRID_API void __read(::IceInternal::BasicStream*, ServerDynamicInfoSeq&, __U__ServerDynamicInfoSeq);

struct AdapterDynamicInfo
{
    ::std::string id;
    ::Ice::ObjectPrx proxy;

    ICE_GRID_API bool operator==(const AdapterDynamicInfo&) const;
    ICE_GRID_API bool operator!=(const AdapterDynamicInfo&) const;
    ICE_GRID_API bool operator<(const AdapterDynamicInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceGrid::AdapterDynamicInfo> AdapterDynamicInfoSeq;

class __U__AdapterDynamicInfoSeq { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const AdapterDynamicInfoSeq&, __U__AdapterDynamicInfoSeq);
ICE_GRID_API void __read(::IceInternal::BasicStream*, AdapterDynamicInfoSeq&, __U__AdapterDynamicInfoSeq);

struct NodeDynamicInfo
{
    ::std::string name;
    ::IceGrid::NodeInfo info;
    ::IceGrid::ServerDynamicInfoSeq servers;
    ::IceGrid::AdapterDynamicInfoSeq adapters;

    ICE_GRID_API bool operator==(const NodeDynamicInfo&) const;
    ICE_GRID_API bool operator!=(const NodeDynamicInfo&) const;
    ICE_GRID_API bool operator<(const NodeDynamicInfo&) const;

    ICE_GRID_API void __write(::IceInternal::BasicStream*) const;
    ICE_GRID_API void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::IceGrid::NodeDynamicInfo> NodeDynamicInfoSeq;

class __U__NodeDynamicInfoSeq { };
ICE_GRID_API void __write(::IceInternal::BasicStream*, const NodeDynamicInfoSeq&, __U__NodeDynamicInfoSeq);
ICE_GRID_API void __read(::IceInternal::BasicStream*, NodeDynamicInfoSeq&, __U__NodeDynamicInfoSeq);

}

namespace IceGrid
{

class ICE_GRID_API AMI_NodeObserver_init : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::NodeObserverPrx&, const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_NodeObserver_init> AMI_NodeObserver_initPtr;

class ICE_GRID_API AMI_RegistryObserver_init : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::IceGrid::RegistryObserverPrx&, ::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::IceGrid::AMI_RegistryObserver_init> AMI_RegistryObserver_initPtr;

}

namespace IceAsync
{

}

namespace IceProxy
{

namespace IceGrid
{

class ICE_GRID_API NodeObserver : virtual public ::IceProxy::Ice::Object
{
public:

    void init(const ::IceGrid::NodeDynamicInfoSeq&);
    void init(const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&);
    void init_async(const::IceGrid::AMI_NodeObserver_initPtr&, const ::IceGrid::NodeDynamicInfoSeq&);
    void init_async(const::IceGrid::AMI_NodeObserver_initPtr&, const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&);

    void nodeUp(const ::IceGrid::NodeDynamicInfo&);
    void nodeUp(const ::IceGrid::NodeDynamicInfo&, const ::Ice::Context&);

    void nodeDown(const ::std::string&);
    void nodeDown(const ::std::string&, const ::Ice::Context&);

    void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&);
    void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&, const ::Ice::Context&);

    void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&);
    void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_GRID_API RegistryObserver : virtual public ::IceProxy::Ice::Object
{
public:

    void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&);
    void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&);
    void init_async(const::IceGrid::AMI_RegistryObserver_initPtr&, ::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&);
    void init_async(const::IceGrid::AMI_RegistryObserver_initPtr&, ::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&);

    void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&);
    void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    void applicationRemoved(::Ice::Int, const ::std::string&);
    void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Context&);

    void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&);
    void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_GRID_API Session : virtual public ::IceProxy::Glacier2::Session
{
public:

    void keepAlive();
    void keepAlive(const ::Ice::Context&);

    ::Ice::Int getTimeout();
    ::Ice::Int getTimeout(const ::Ice::Context&);

    ::IceGrid::QueryPrx getQuery();
    ::IceGrid::QueryPrx getQuery(const ::Ice::Context&);

    ::IceGrid::AdminPrx getAdmin();
    ::IceGrid::AdminPrx getAdmin(const ::Ice::Context&);

    void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&);
    void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&, const ::Ice::Context&);

    void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&);
    void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&, const ::Ice::Context&);

    ::Ice::Int startUpdate();
    ::Ice::Int startUpdate(const ::Ice::Context&);

    void addApplication(const ::IceGrid::ApplicationDescriptor&);
    void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    void syncApplication(const ::IceGrid::ApplicationDescriptor&);
    void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&);
    void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    void removeApplication(const ::std::string&);
    void removeApplication(const ::std::string&, const ::Ice::Context&);

    void finishUpdate();
    void finishUpdate(const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

class ICE_GRID_API SessionManager : virtual public ::IceProxy::Glacier2::SessionManager
{
public:

    ::IceGrid::SessionPrx createLocalSession(const ::std::string&);
    ::IceGrid::SessionPrx createLocalSession(const ::std::string&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace IceGrid
{

class ICE_GRID_API NodeObserver : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void init(const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&) = 0;

    virtual void nodeUp(const ::IceGrid::NodeDynamicInfo&, const ::Ice::Context&) = 0;

    virtual void nodeDown(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&, const ::Ice::Context&) = 0;

    virtual void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&, const ::Ice::Context&) = 0;
};

class ICE_GRID_API RegistryObserver : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&) = 0;

    virtual void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&) = 0;

    virtual void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Context&) = 0;

    virtual void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&) = 0;
};

class ICE_GRID_API Session : virtual public ::IceDelegate::Glacier2::Session
{
public:

    virtual void keepAlive(const ::Ice::Context&) = 0;

    virtual ::Ice::Int getTimeout(const ::Ice::Context&) = 0;

    virtual ::IceGrid::QueryPrx getQuery(const ::Ice::Context&) = 0;

    virtual ::IceGrid::AdminPrx getAdmin(const ::Ice::Context&) = 0;

    virtual void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&, const ::Ice::Context&) = 0;

    virtual void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&, const ::Ice::Context&) = 0;

    virtual ::Ice::Int startUpdate(const ::Ice::Context&) = 0;

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&) = 0;

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&) = 0;

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&) = 0;

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&) = 0;

    virtual void finishUpdate(const ::Ice::Context&) = 0;
};

class ICE_GRID_API SessionManager : virtual public ::IceDelegate::Glacier2::SessionManager
{
public:

    virtual ::IceGrid::SessionPrx createLocalSession(const ::std::string&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace IceGrid
{

class ICE_GRID_API NodeObserver : virtual public ::IceDelegate::IceGrid::NodeObserver,
				  virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void init(const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&);

    virtual void nodeUp(const ::IceGrid::NodeDynamicInfo&, const ::Ice::Context&);

    virtual void nodeDown(const ::std::string&, const ::Ice::Context&);

    virtual void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&, const ::Ice::Context&);

    virtual void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&, const ::Ice::Context&);
};

class ICE_GRID_API RegistryObserver : virtual public ::IceDelegate::IceGrid::RegistryObserver,
				      virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&);

    virtual void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Context&);

    virtual void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);
};

class ICE_GRID_API Session : virtual public ::IceDelegate::IceGrid::Session,
			     virtual public ::IceDelegateM::Glacier2::Session
{
public:

    virtual void keepAlive(const ::Ice::Context&);

    virtual ::Ice::Int getTimeout(const ::Ice::Context&);

    virtual ::IceGrid::QueryPrx getQuery(const ::Ice::Context&);

    virtual ::IceGrid::AdminPrx getAdmin(const ::Ice::Context&);

    virtual void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&, const ::Ice::Context&);

    virtual void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::Ice::Int startUpdate(const ::Ice::Context&);

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual void finishUpdate(const ::Ice::Context&);
};

class ICE_GRID_API SessionManager : virtual public ::IceDelegate::IceGrid::SessionManager,
				    virtual public ::IceDelegateM::Glacier2::SessionManager
{
public:

    virtual ::IceGrid::SessionPrx createLocalSession(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace IceGrid
{

class ICE_GRID_API NodeObserver : virtual public ::IceDelegate::IceGrid::NodeObserver,
				  virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void init(const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Context&);

    virtual void nodeUp(const ::IceGrid::NodeDynamicInfo&, const ::Ice::Context&);

    virtual void nodeDown(const ::std::string&, const ::Ice::Context&);

    virtual void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&, const ::Ice::Context&);

    virtual void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&, const ::Ice::Context&);
};

class ICE_GRID_API RegistryObserver : virtual public ::IceDelegate::IceGrid::RegistryObserver,
				      virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Context&);

    virtual void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Context&);

    virtual void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);
};

class ICE_GRID_API Session : virtual public ::IceDelegate::IceGrid::Session,
			     virtual public ::IceDelegateD::Glacier2::Session
{
public:

    virtual void keepAlive(const ::Ice::Context&);

    virtual ::Ice::Int getTimeout(const ::Ice::Context&);

    virtual ::IceGrid::QueryPrx getQuery(const ::Ice::Context&);

    virtual ::IceGrid::AdminPrx getAdmin(const ::Ice::Context&);

    virtual void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&, const ::Ice::Context&);

    virtual void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&, const ::Ice::Context&);

    virtual ::Ice::Int startUpdate(const ::Ice::Context&);

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Context&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Context&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Context&);

    virtual void finishUpdate(const ::Ice::Context&);
};

class ICE_GRID_API SessionManager : virtual public ::IceDelegate::IceGrid::SessionManager,
				    virtual public ::IceDelegateD::Glacier2::SessionManager
{
public:

    virtual ::IceGrid::SessionPrx createLocalSession(const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IceGrid
{

class ICE_GRID_API NodeObserver : virtual public ::Ice::Object
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void init(const ::IceGrid::NodeDynamicInfoSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___init(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void nodeUp(const ::IceGrid::NodeDynamicInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___nodeUp(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void nodeDown(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___nodeDown(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateServer(const ::std::string&, const ::IceGrid::ServerDynamicInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateServer(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateAdapter(const ::std::string&, const ::IceGrid::AdapterDynamicInfo&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateAdapter(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__NodeObserverPtr(void*, ::Ice::ObjectPtr&);

class ICE_GRID_API RegistryObserver : virtual public ::Ice::Object
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void init(::Ice::Int, const ::IceGrid::ApplicationDescriptorSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___init(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void applicationAdded(::Ice::Int, const ::IceGrid::ApplicationDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___applicationAdded(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void applicationRemoved(::Ice::Int, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___applicationRemoved(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void applicationUpdated(::Ice::Int, const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___applicationUpdated(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__RegistryObserverPtr(void*, ::Ice::ObjectPtr&);

class ICE_GRID_API Session : virtual public ::Glacier2::Session
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void keepAlive(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___keepAlive(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int getTimeout(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getTimeout(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::QueryPrx getQuery(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getQuery(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual ::IceGrid::AdminPrx getAdmin(const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___getAdmin(::IceInternal::Incoming&, const ::Ice::Current&) const;

    virtual void setObservers(const ::IceGrid::RegistryObserverPrx&, const ::IceGrid::NodeObserverPrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___setObservers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setObserversByIdentity(const ::Ice::Identity&, const ::Ice::Identity&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___setObserversByIdentity(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int startUpdate(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___startUpdate(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___addApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void syncApplication(const ::IceGrid::ApplicationDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___syncApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateApplication(const ::IceGrid::ApplicationUpdateDescriptor&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___updateApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void removeApplication(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___removeApplication(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void finishUpdate(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___finishUpdate(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__SessionPtr(void*, ::Ice::ObjectPtr&);

class ICE_GRID_API SessionManager : virtual public ::Glacier2::SessionManager
{
public:

    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::IceGrid::SessionPrx createLocalSession(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::IceInternal::DispatchStatus ___createLocalSession(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

void ICE_GRID_API __patch__SessionManagerPtr(void*, ::Ice::ObjectPtr&);

}

#endif
